
var isRunning = false;

function updateUI(jsonObject)
{
    var inputCombo = document.getElementById('inputDeviceList');
    var outputCombo = document.getElementById('outputDeviceList');

    // clear input combo
    while (inputCombo.options.length > 0) 
    {                
        inputCombo.remove(0);
    } 

    // clear output combo
    while (outputCombo.options.length > 0) 
    {                
        outputCombo.remove(0);
    } 

    // populate input combo
    var i;
    for(i = 0; i < jsonObject.inputDevices.length; i++) 
    {   
        var option = document.createElement('option');
        option.text = option.value = jsonObject.inputDevices[i];
        inputCombo.add(option, i);
    }

    // populate output combo
    for(i = 0; i < jsonObject.outputDevices.length; i++) 
    {   
        var option = document.createElement('option');
        option.text = option.value = jsonObject.outputDevices[i];
        outputCombo.add(option, i);
    }

    // select devices
    var selectedIndex = jsonObject.selectedInputDevice;
    inputCombo.options[selectedIndex].selected = true;

    selectedIndex = jsonObject.selectedOutputDevice;
    outputCombo.options[selectedIndex].selected = true;

    var chkProcessAudio = document.getElementById('chkProcessAudio');
    chkProcessAudio.checked = jsonObject.processAudio;

    var sldrStreamGain = document.getElementById('sldrStreamGain');
    sldrStreamGain.value = jsonObject.streamGain;

    var btnStart = document.getElementById('btnStart');
    btnStart.textContent = jsonObject.isStreaming ? 'Stop' : 'Start';

    isRunning = jsonObject.isStreaming;
    inputCombo.disabled = jsonObject.isStreaming;
    outputCombo.disabled = jsonObject.isStreaming;
}

function loadStateJson()
{
    var xmlhttp = new XMLHttpRequest();
    var url = "state.json";

    xmlhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            var jsonObject = JSON.parse(this.responseText);
            updateUI(jsonObject);
        }
    };
    xmlhttp.open("GET", url, true);
    xmlhttp.send();
}

function onDocumentLoad()
{
	loadStateJson();
}

function postUpdate(paramIndex, paramVal)
{
    var xhr = new XMLHttpRequest();
    xhr.open("POST", "update", true);
    xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
    xhr.send('paramIndex='+paramIndex+'&paramVal='+paramVal);
}

function onInputComboChange()
{
    var inputCombo = document.getElementById('inputDeviceList');
    postUpdate(1, inputCombo.selectedIndex);    
}

function onOutputComboChange()
{
    var outputCombo = document.getElementById('outputDeviceList');
    postUpdate(2, outputCombo.selectedIndex);    
}

function onProcessAudioChange()
{
    var chkProcessAudio = document.getElementById('chkProcessAudio');
    postUpdate(3, chkProcessAudio.checked ? 1 : 0);    
}

function onStreamGainChange()
{
    var sldrStreamGain = document.getElementById('sldrStreamGain');
    postUpdate(4, sldrStreamGain.value);       
}

function setDisableComponents(disable, ignoreInputOutputCombo)
{
    var btnStart = document.getElementById('btnStart');
    btnStart.disabled = disable;

    var sldrStreamGain = document.getElementById('sldrStreamGain');
    sldrStreamGain.disabled = disable;

    var chkProcessAudio = document.getElementById('chkProcessAudio');
    chkProcessAudio.disabled = disable;

    var btnRefresh = document.getElementById('btnRefresh');
    btnRefresh.disabled = disable;

    if(!ignoreInputOutputCombo)
    {
        var outputCombo = document.getElementById('outputDeviceList');
        outputCombo.disabled = disable;

        var inputCombo = document.getElementById('inputDeviceList');
        inputCombo.disabled = disable;
    }
}

function onStartButtonPress()
{
    postUpdate(5, isRunning ? 0 : 1);
    setDisableComponents(true, false);

    setTimeout(function() {
        setDisableComponents(false, true);
        loadStateJson();
    }, 2000);
}